/**
 * An ice cream is a frozen snak that is usually made of milk and cream.
 *
 * An ice cream can have many flavors and can be served with a waffle cone or
 * in a cup.
 *
 * An ice cream can also be lactose free
 */
public abstract class IceCream {

  // AF(this):
  // an ice cream's flavor is represented by this.flavor
  // this.waffleCone represents whether the ice cream is served on a waffle cone
  // this.lactoseFree represents whether the ice cream is lactose free
  //
  // RI:
  // this.flavor != null

  /** the flavor of the ice cream */
  protected String flavor;
  /** whether this ice cream is served on a waffle cone */
  protected boolean waffleCone;
  /** whether this ice cream is lactose free */
  protected boolean lactoseFree;

  /** @return the flavor of this ice cream */
  public abstract String getFlavor();
  /** @return true iff this ice cream is served on a waffle cone */
  public abstract boolean hasWaffleCone();
  /** @return true iff this ice cream is lactose free */
  public abstract boolean isLactoseFree();

  /**
   * Returns the string representation of an ice cream
   *
   * @return String in the format FLAVOR(WAFFLE_CONE|CUP)(:LACTOSE_FREE)?
   */
  @Override
  public String toString() {
    String container = waffleCone ? "(WAFFLE_CONE)" : "(CUP)";
    String lactose = lactoseFree ? ":LACTOSE_FREE" : "";
    return this.flavor +  container + lactose;
  }
}
